/*
  libcannaʶƥǡȤꤹؿ
  lib/RKC/wconvert.cˤRkcSendWRequest(),RkcRecvWReply()ȤäƤ뤬
  ˻Ȥäפ
*/
#define _XOPEN_SOURCE
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include "pkt.h"
#include "ut.h"
#include "corr.h"

// lib/RKC/wconvert.c
int RkcSendWRequest(const void* buffer, int size );
int RkcRecvWReply(void* buf, int bufsize,int* len_return,void** alloc);

bool Snd1(int8_t mj,int8_t mn)
{
    Snd1_t req;
    req.major = mj;
    req.minor = mn;
    req.len = 0;
    return RkcSendWRequest(&req,sizeof(req))==0;
}

bool Snd2(int8_t mj,int8_t mn,int16_t p1)
{
    Snd2_t req;
    req.h.major = mj;
    req.h.minor = mn;
    req.h.len = Swap2(2);
    req.cxn = Swap2(p1);
    return RkcSendWRequest(&req,sizeof(req))==0;
}

bool Snd5(int8_t mj,int8_t mn,int16_t p1,uint16_t p2,int32_t p3)
{
    Snd5_t req;
    req.h.major = mj;
    req.h.minor = mn;
    req.h.len = Swap2(sizeof(p1)+sizeof(p2)+sizeof(p3));
    req.cxn = Swap2(p1);
    req.sz = Swap2(p2);
    req.mode = Swap4(p3);
    return RkcSendWRequest(&req,sizeof(req))==0;
}    

bool Snd11(int8_t mj,int8_t mn,int16_t p1,int16_t p2,const uint16_t* str)
{
    int strsz = (WcLen(str)+1)*2;
    char buf[sizeof(Snd11_t)+strsz];
    Snd11_t *req = (Snd11_t*)buf;
    req->h.major = mj;
    req->h.minor = mn;
    req->h.len = Swap2(sizeof(p1)+sizeof(p2)+strsz);
    req->cxn = Swap2(p1);
    req->cl = Swap2(p2);
    WcCpy(req->str,str);
    return RkcSendWRequest(buf,sizeof(buf))==0;
}

//sNULLǽ
bool Snd17a(int8_t mj,int8_t mn,const char** s)
{
    int sz = 1,len;
    for(const char** p=s; *p!=NULL; ++p)
	sz += strlen(*p)+1;
    char buf[sizeof(Snd17_t)+sz];
    Snd17_t *req = (Snd17_t*)buf;

    req->h.major = mj;
    req->h.minor = mn;
    req->h.len = Swap2(sz);

    char *p = req->str;
    while(*s != NULL){
	len = strlen(*s)+1;
	memcpy(p,*s,len);
	p += len;
	++s;
    }
    *(p++) = 0;
    return RkcSendWRequest(buf,sizeof(buf))==0;
}

/*
  buf֤Хåեlibcanna¦ХåեݤȤϤΥɥ쥹֤
  顼λNULL
*/
void* read_from_server(void* buf,int bufsize,int* len)
{
    void *al=NULL;
    if(RkcRecvWReply(buf,bufsize,len,&al)==0){
	if(al!=NULL)
	    buf = al;
    }else
	buf = NULL;
    return buf;
}

char Rcv2(void)
{
    Rcv2_t r,*p;
    char num=-1;
    if((p=read_from_server(&r,sizeof(r),NULL))!=NULL){
	num = p->num;
	if(p != &r)
	    free(p);
    }
    return num;
}

//ʸmallocǳݤ
uint16_t* Rcv3(void)
{
    Rcv3_t r,*p;
    uint16_t *c=NULL;
    if((p = read_from_server(&r,sizeof(r),NULL)) != NULL){
	if(p->st == 0){
	    c = malloc(WcLen(p->str)*2+2);
	    WcCpy(c,p->str);
	}
	if(p != &r)
	    free(p);
    }
    return c;
}

char* Rcv6(int16_t* p1,char* p2,int bufsz,int* p2len)
{
    if((p2 = read_from_server(p2,bufsz,p2len)) != NULL){
	Rcv6_t *p = (Rcv6_t*)p2;
	*p1 = p->p1;
	*p2len -= sizeof(Rcv6_t);
	memcpy(p,p->p2,*p2len);
    }
    return p2;
}

/*
  p2֤
  p2==NULL or p2sz0ΤȤor礭­ʤȤmallocǳݤ
*/
uint16_t* Rcv7(int16_t* p1,uint16_t* p2,int p2sz,bool sw)
{
    char buf[sizeof(Rcv7_t)+p2sz*2];
    Rcv7_t *r=(Rcv7_t*)buf,*p;

    if((p = read_from_server(r,sizeof(buf),NULL)) != NULL){
	*p1 = Swap2(p->p1);
	int sz = p->h.len-sizeof(Rcv7_t); //p->sΥХȿ
	if(p2==NULL || p2sz*2<sz)
	    p2 = malloc(sz);
	if(sw)
	    swab(p->s,p2,sz);
	else
	    memcpy(p2,p->s,sz);
	if(p != r)
	    free(p);
    }else
	p2=NULL;
    return p2;
}

char* Rcv11(int* p1,int* p2,int* p3,char* p4,int p4sz)
{
    int *pi[]={p1,p2,p3};
    char buf[sizeof(Rcv11_t)+p4sz];
    Rcv11_t *r=(Rcv11_t*)buf,*p;

    if((p = read_from_server(r,sizeof(buf),NULL)) != NULL){
	for(int n=0; n<3; ++n)
	    *pi[n] = *RevInt(p->pi+n);
	if(p != r)
	    p4 = malloc(p->h.len - sizeof(*p));
	strcpy(p4,p->p4);
    }else
	p4 = NULL;
    return p4;
}
